const StoreCartsInfo_color = ({ l, p_id, cls, data, prod, color: { id: c_id, color }, local, lang, set, sort }) => {

	if ('' == data.extended || !data.extended) return ''

	const bg = url => ({ backgroundImage: 'url(' + url + ')' }),
		order = 'pre-order-' + local,
		defSort = [],
		colorBar = {}

	colorBar[p_id] = {
		active: c_id == p_id ? 'active' : '',
		preorder: 'object' === typeof data[order] && data[order].active ? 'preorder' : '',
		ico: bg(data.attrs['color-ico']),
		click: () => {
			set(p_id, p_id, data.attrs.color)
			l('store-color')
		}
	}

	defSort.push(p_id)

	let colorBarLength = () => data.extended.length > 5 ? 'large' : 'small'

	data.extended.map(id => {

		defSort.push(id)

		if ('object' === typeof prod[id] && 'boolean' === typeof prod[id].hidden && !prod[id].hidden) {

			let { attrs } = prod[id]

			colorBar[id] = {
				active: c_id == id ? 'active' : '',
				preorder: 'object' === typeof prod[id][order] && prod[id][order].active ? 'preorder' : '',
				ico: bg(attrs['color-ico']),
				click: () => {
					set(p_id, id, attrs.color)
					l('store-color')
				}
			}

		}

	})

	sort = sort || defSort

	return (

		<div className={cls + ' choice-color'}>

			{lang.chose_color} <span>{lang['color_' + color]}</span>

			<div className={"color-bar " + colorBarLength()}>

				{sort.map(id => {

					if ('object' === typeof colorBar[id]) {

						let { active, preorder, ico, click } = colorBar[id]

						return (

							<p className={active}> <div className={preorder} onClick={click} style={ico} /></p>

						)

					}

				})}

			</div>

		</div>

	)

}, StoreCartsInfo_preorder = ({
	order, color: { id: c_id }, prod: { [c_id]: data }, s_ok,
	lang: { name, name_valid, mail, mail_valid, pre_order_privacy, pre_order_btn },
	v_name, v_mail, name_v, mail_v, chang, p_order, preorId, children
}) => 'object' === typeof data[order] && data[order].active ? (
	// preorId это как раз показывать текст спасибо или форму предзаказа
	<div className={preorId ? 'pre-order-form send-ok' : 'pre-order-form'} >

		<div className="text" dangerouslySetInnerHTML={{ __html: data[order].text }} />

		<div className="form-inps">

			<label className={!name_v && 'err'}>

				{name} <input value={v_name} onChange={ev => chang(ev, 'name')} type="text" /> <p>{name_valid}</p>

			</label>

			<label className={!mail_v && 'err'}>

				{mail} <input value={v_mail} onChange={ev => chang(ev, 'mail')} type="text" /> <p>{mail_valid}</p>

			</label>

		</div>

		<div className="privacy" dangerouslySetInnerHTML={{ __html: pre_order_privacy }} />

		<ShopButton click={() => p_order(c_id)} cls="pre-order-btn" text={pre_order_btn} />

		<div className="shop__form-pre-order-send-ok" dangerouslySetInnerHTML={{ __html: data[order].thanks }} />

	</div >

) : children

class StoreCartsInfo extends React.Component {

	static contextType = ShopAppContext

	constructor(props) {

		super(props)

		this.state = {
			id: 0,
			name: '',
			mail: '',
			nameValid: true,
			mailValid: true,
			colorText: '',
			borderColor: '',
			buttonActive: false,
			sendOK: true,
			sorted: false
		}

	}

	PriceHelper = p => this.context.factory.PriceHelper(p, this.context.pageData.local)

	add = id => {

		const { SetProduct, HandleBasketWidget, DataLayer } = this.context.factory

		SetProduct('add', id, 1)

		HandleBasketWidget(true)

		DataLayer('store-tobacket')

		setTimeout(() => { HandleBasketWidget(false) }, 5000);

	}

	preorderChange = (ev, k) => {

		this.setState(() => {

			let obj = {}

			obj[k] = ev.target.value

			return obj

		})

	}

	// функция которая проверяет есть ли id в списке предзаказанного
	preorderCheck = ({ id }) => {

		id = parseInt(id)

		let getPreOrders = this.context.factory.PreOrder()

		if ('undefined' === typeof getPreOrders) return false

		return getPreOrders.indexOf(id) == -1 ? false : true

	}

	submitPreOrder = id => {

		const { name, mail, nameValid, mailValid } = this.state,
			{
				pageData: { local }, shopData: { products: { [id]: { ['pre-order-' + local]: data } } },
				factory: { EmailValidations, PreOrder }
			} = this.context

		let send = true,
			nameV = name.trim(name)

		if (nameV == '' || nameV.length < 2) { send = false }

		if (mail == '' || !EmailValidations(mail)) { send = false }

		this.setState({ nameValid: nameV.length > 1, mailValid: mail != '' && EmailValidations(mail) })

		if (send) {
			$.post('/staging/wp-content/themes/healbe/inc/shop_get_response.php', {
				name: name,
				mail: mail,
				fields: data['custom-fields'] || [],
				groups: data.groups || []
			}, ({ resp }) => {

				if (resp == 'ok') {
					PreOrder(id)
					this.setState({ name: '', mail: '' })
				}

			});
		}

	}

	dialog = ev => ev.target.className == 'shop__ship-btn' ? this.context.factory.DeliveryDialog(true) : ''

	render() {

		const { id: p_id } = this.props,
			{ id: s_id, sendOK, name: val_name, mail: val_mail, nameValid, mailValid, sorted } = this.state,
			{
				shopData: { products: p, products: { [p_id]: data } },
				pageData: { local, lang },
				factory: { GetColorItem: fGetColorItem, SetColorItem: fSetColorItem, DataLayer: fDataLayer }
			} = this.context,
			price = this.PriceHelper(data.prices),
			header = data['header-' + local],
			sort = data['sorted-' + local] || null,
			description = data['description-' + local].replace('{price}', price).replace('{shipping}', lang.payment_delivery),
			getColorItem = fGetColorItem(p_id) || { id: p_id, color: data.attrs.color },
			preor_id_check = this.preorderCheck(getColorItem)

		if (p_id != s_id) this.setState({ id: p_id, sendOK: false })

		setTimeout(() => {

			if (sort && !sorted) {

				fSetColorItem(p_id, sort[0], p[sort[0]].attrs.color)

				this.setState({ sorted: true })

			} else if (!sorted) this.setState({ sorted: true })

		}, 100)

		return (

			<div className={data['pre-order-ru']['active'] ? "cart-info preorder" : "cart-info"}>

				<StoreCartsInfo_color
					p_id={p_id}
					cls='top-color-item'
					data={data}
					prod={p}
					color={getColorItem}
					local={local}
					lang={lang}
					l={fDataLayer}
					set={fSetColorItem}
					sort={sort} />

				<div className="header header-info" dangerouslySetInnerHTML={{ __html: header }} />

				<span onClick={this.dialog} dangerouslySetInnerHTML={{ __html: description }} />

				{/* <span className="payment-delivery" onClick={this.dialog}>

					{lang.payment_delivery}

				</span> */}

				<StoreCartsInfo_color
					p_id={p_id}
					cls='bottom-color-item'
					data={data}
					prod={p}
					color={getColorItem}
					local={local}
					lang={lang}
					set={fSetColorItem}
					l={fDataLayer}
					sort={sort} />

				<StoreCartsInfo_preorder
					order={'pre-order-' + local}
					color={getColorItem}
					preorId={preor_id_check}
					prod={p}
					s_ok={sendOK}
					lang={lang}
					v_name={val_name}
					v_mail={val_mail}
					name_v={nameValid}
					mail_v={mailValid}
					chang={this.preorderChange}
					p_order={this.submitPreOrder}
				>

					<StoreCartsInfo_btnsBar
						add={this.add}
						lang={lang}
						local={local}
						color={getColorItem}
						prod={p}
						data={data}
					/>

				</StoreCartsInfo_preorder>

			</div >

		)

	}

}

const StoreCartsInfo_btnsBar = ({ add, lang: { add_to_cart }, local, color: { id: c_id }, data, prod }) => {

	const marketBtn = () => {

		const data = prod[c_id],
			active = data.button_active,
			image = data.button_image,
			imageHover = data.button_hover,
			imageActive = data.image_active,
			imageMobile = data.mobile_button_image,
			imageMobileActive = data.mobile_button_image_hover,
			buttonLink = data.link_btn

		if ('object' === typeof active && active[local] != 0 && 'object' === typeof image && 'object' === typeof imageHover && 'object' === typeof imageMobile && 'object' === typeof imageMobileActive && 'object' === typeof imageActive) {

			return (
				<>
					<a className="market-button" href={buttonLink[local]} target="_blank">
						<img className="button-image" src={image[local]} />
						<img className="button-hover" src={imageHover[local]} />
					</a>

					<a className="market-button-mob" href={buttonLink[local]} target="_self">
						<img className="button-mobile" src={imageMobile[local]} />
						{/* <img className="button-mobile-active" src={imageMobileActive[local]} /> */}
					</a>
				</>
			)

		} else return ''

	},
		StoreCartsInfo_btnsBarView = ({ c, t }) => <div className="btns-bar"> <ShopButton click={c} cls="add-to-cart" text={t} />{marketBtn()}</div>

	return <StoreCartsInfo_btnsBarView c={() => add(c_id)} t={add_to_cart} />

}